#include "stdafx.h"
#include "camera.h"
#include "opencv2/highgui/highgui_c.h"
#include "../../include/iANPR.h"
#include <stdio.h>
#include <Windows.h>
#include "Form1.h"
#include <time.h> 

#define WIDTHBYTES(bits) (((bits) + 31) / 32 * 4)

CvCapture* capture;
bool stop;
HBITMAP Bitmap = NULL;
CRITICAL_SECTION cs;

//   
int all;
CvRect Rects[100];				
char** res;
char outbuf[256];

HBITMAP CreateRGBBitmap(IplImage* _Grab )
{
    char *App;
    LPBITMAPINFO lpbi = new BITMAPINFO;
    lpbi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
    lpbi->bmiHeader.biWidth = _Grab->width;
    lpbi->bmiHeader.biHeight =_Grab->height;
    lpbi->bmiHeader.biPlanes = 1;
    lpbi->bmiHeader.biBitCount = 24;
    lpbi->bmiHeader.biCompression = BI_RGB;
    lpbi->bmiHeader.biSizeImage = WIDTHBYTES((DWORD)_Grab->width * 8) * _Grab->height;
    lpbi->bmiHeader.biXPelsPerMeter = 0;
    lpbi->bmiHeader.biYPelsPerMeter = 0;
    lpbi->bmiHeader.biClrUsed = 0;
    lpbi->bmiHeader.biClrImportant = 0;
    void* pBits;
    HBITMAP hBitmap = CreateDIBSection( NULL,lpbi,DIB_RGB_COLORS,(void **)&pBits,NULL,0 );
    delete lpbi;
    if ( hBitmap ) App=(char*)pBits;
	long int length=0;
    if(_Grab->nChannels==1) //   
    {
           length = _Grab->width*(_Grab->height);
           for (int i=0;i<_Grab->height;i++)
           {
                   for (int j=0;j<_Grab->width;j++)
                   {
                           App[_Grab->width*3*(_Grab->height-i-1)+j*3]=_Grab->imageData[_Grab->width*(i)+j];
                           App[_Grab->width*3*(_Grab->height-i-1)+j*3+1]=_Grab->imageData[_Grab->width*(i)+j];
                           App[_Grab->width*3*(_Grab->height-i-1)+j*3+2]=_Grab->imageData[_Grab->width*(i)+j];
                   }
           }
    }
    if(_Grab->nChannels==3) // 
    {
           for (int i=0;i<_Grab->height;i++)
           {
                   //  
                   memcpy(App+_Grab->width*3*(_Grab->height-i-1),_Grab->imageData+_Grab->width*3*i,_Grab->width*3);           
           }
    }	
    return hBitmap;
}

DWORD WINAPI ImageProcess(LPVOID)
{
	ANPR_OPTIONS a;		
	a.Detect_Mode = ANPR_DETECTCOMPLEXMODE;
	a.min_plate_size = 500;
	a.max_plate_size = 25000;
	a.max_text_size = 20;		
	a.type_number = ANPR_RUSSIAN_BASE2;				
	a.flags = 0;

	CvSize Size = cvSize( 320, 240 );
	IplImage* small_image = cvCreateImage( Size, 8, 3 );
	IplImage* object = 0;

	char mem[100][20];
	int all_mem = 0;

	for(;;)
	{
		IplImage* frame = 0;    
		frame = cvQueryFrame(capture );
		if( !frame )
            break;		
		if (!object)
		{
			object = cvCreateImage(cvGetSize(frame), 8, 1);			
			cvZero( object );
            object->origin = frame->origin;				
		}
		cvCvtColor( frame, object, CV_BGR2GRAY );
		cvSaveImage( "test.jpg", object );		
		all = 100;

		int i1;
		
		i1 = anprPlate( object, a, &all, Rects, res ); 		

		int number = 0;
		if ( i1 == 0 )
		{						
			for(int j = 0; j < all; j++ )				
			{				
				if ( strlen( res[j] ) >= 8 )
				{
					int k =0;
					for( int j1 = 0; j1 < all_mem; j1++ )
						if ( strcmp( res[j], mem[j1]) == 0 ) k = 1;	//      ,    
					if ( k == 0 ) continue;		
					cvRectangle( frame,cvPoint( Rects[j].x, Rects[j].y),cvPoint(Rects[j].x+Rects[j].width,
						Rects[j].y+Rects[j].height), CV_RGB(255,255,0), 2);
					
					CvFont font;
					float aa=0.001f*frame->width;
					cvInitFont( &font, CV_FONT_HERSHEY_SIMPLEX, aa,
									aa,0,1, 8 ); 
					CvPoint pp2,pp1;
					pp2.x=Rects[j].x;
					pp2.y=Rects[j].y;
					pp1.x=Rects[j].x+1;
					pp1.y=Rects[j].y+1;
					cvPutText( frame, res[j], pp1, &font, CV_RGB(0,0,0) );
					cvPutText( frame, res[j], pp2, &font, CV_RGB(0,255,0) );
					if ( j == 0 )
					{
						//   ,        
						number = 1;
					}

				}			
			}
			//   
			for(int j = 0; j < all; j++ )				
			{
				for( i1 = 0; i1 < strlen( res[j] ); i1++ )
					if ( res[j][i1] == '?' ) {
						i1 = -1;
						break;
					}
				if ( i1 == -1 ) continue;
				if ( strlen( res[j] ) >= 8 )
				{
					strcpy( mem[j], res[j] );
				}
			}
			all_mem = all;
		}		

		cvResize( frame, small_image );

EnterCriticalSection(&cs);
		//  
		if ( number == 1 )
		{
			time_t rawtime; 
			struct tm * timeinfo; 
			time ( &rawtime ); 
			timeinfo = localtime ( &rawtime ); 

			sprintf( outbuf,"Time and data: %s - Number: %s\n", asctime (timeinfo), res[0] ); 
		}
		else outbuf[0] = 0;

		if ( Bitmap != NULL ) DeleteObject(Bitmap);		
		Bitmap = CreateRGBBitmap(frame);	
LeaveCriticalSection(&cs);		
		Sleep( 2 ); //     
		if ( stop ) break;
	}

	cvReleaseCapture( &capture );
	capture = 0;
	cvReleaseImage( &small_image );
	cvReleaseImage( &object );
	DeleteCriticalSection(&cs);
	
	for(int j=0;j<100;j++) delete [] res[j];
	delete [] res;	

	return 0;
}

int Start( char* IP, char* Login, char* Password  )
{
	char buf[256];

	sprintf( buf, "http://%s:%s@%s/video.cgi?.mjpg", Login, Password, IP );	

	if ( strcmp( IP, "127.0.0.1" ) == 0 )
		capture = cvCaptureFromCAM( 0 );
	else
		capture = cvCaptureFromFile( buf );
	
	if ( capture == NULL ) return 1;

	//     
	DWORD lpT;
	stop = false;
	InitializeCriticalSection(&cs);
	all = 100;
	res = new char*[all];
	for(int j=0;j<all;j++) res[j] = new char[20];
	CreateThread( NULL,0,ImageProcess,NULL,0,&lpT); 
	return 0;
}

void Stop()
{
	stop = true;
}

HBITMAP LoadImage_()
{
	return Bitmap;
}

CRITICAL_SECTION* Section_()
{
	return &cs;
}

void GetResult( char* dst )
{
	strcpy_s( dst, 256, outbuf );
}